Importing crypto libraries

- crypto/external/bsd/heimdal
 - crypto/external/bsd/libsaslc
 - crypto/external/bsd/netpgp
 - crypto/external/bsd/openssl

Change-Id: I91dbf05f33e637edf5b9bb408d5baddd7ba8cf75
This commit is contained in:
2015-10-07 00:45:38 +00:00
parent b1d068470b
commit ebfedea0ce
5082 changed files with 1472353 additions and 12 deletions

View File

@@ -0,0 +1,95 @@
/*
*
* Copyright (c) 2007 Kungliga Tekniska Högskolan
* (Royal Institute of Technology, Stockholm, Sweden).
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* 1. Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
*
* 2. Redistributions in binary form must reproduce the above copyright
* notice, this list of conditions and the following disclaimer in the
* documentation and/or other materials provided with the distribution.
*
* 3. Neither the name of the Institute nor the names of its contributors
* may be used to endorse or promote products derived from this software
* without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
* OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
* OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGE.
*
* Id
*/
import javax.security.auth.login.*;
import javax.security.auth.callback.*;
public class KerberosInit {
private class TestCallBackHandler implements CallbackHandler {
public void handle(Callback[] callbacks)
throws UnsupportedCallbackException {
for (int i = 0; i < callbacks.length; i++) {
if (callbacks[i] instanceof TextOutputCallback) {
TextOutputCallback toc = (TextOutputCallback)callbacks[i];
System.out.println(toc.getMessage());
} else if (callbacks[i] instanceof NameCallback) {
NameCallback nc = (NameCallback)callbacks[i];
nc.setName("lha");
} else if (callbacks[i] instanceof PasswordCallback) {
PasswordCallback pc = (PasswordCallback)callbacks[i];
pc.setPassword("foo".toCharArray());
} else {
throw new
UnsupportedCallbackException(callbacks[i],
"Unrecognized Callback");
}
}
}
}
private TestCallBackHandler getHandler() {
return new TestCallBackHandler();
}
public static void main(String[] args) {
LoginContext lc = null;
try {
lc = new LoginContext("kinit", new KerberosInit().getHandler());
} catch (LoginException e) {
System.err.println("Cannot create LoginContext. " + e.getMessage());
e.printStackTrace();
System.exit(1);
} catch (SecurityException e) {
System.err.println("Cannot create LoginContext. " + e.getMessage());
e.printStackTrace();
System.exit(1);
}
try {
lc.login();
} catch (LoginException e) {
System.err.println("Authentication failed:" + e.getMessage());
e.printStackTrace();
System.exit(1);
}
System.out.println("lc.login ok");
System.exit(0);
}
}

View File

@@ -0,0 +1,44 @@
# Id: Makefile.am 20739 2007-05-31 16:53:21Z lha
include $(top_srcdir)/Makefile.am.common
noinst_DATA = krb5.conf
check_SCRIPTS = $(SCRIPT_TESTS)
SCRIPT_TESTS = check-kinit
TESTS = $(SCRIPT_TESTS)
port = 49188
do_subst = sed -e 's,[@]srcdir[@],$(srcdir),g' \
-e 's,[@]port[@],$(port),g' \
-e 's,[@]objdir[@],$(top_builddir)/tests/java,g'
LDADD = ../../lib/krb5/libkrb5.la $(LIB_roken)
check-kinit: check-kinit.in Makefile
$(do_subst) < $(srcdir)/check-kinit.in > check-kinit.tmp
chmod +x check-kinit.tmp
mv check-kinit.tmp check-kinit
krb5.conf: krb5.conf.in Makefile
$(do_subst) < $(srcdir)/krb5.conf.in > krb5.conf.tmp
mv krb5.conf.tmp krb5.conf
CLEANFILES= \
$(TESTS) \
*.tmp \
*.class \
current-db* \
krb5.conf \
messages.log
EXTRA_DIST = \
KerberosInit.java \
jaas.conf \
check-kinit.in \
have-java.sh \
krb5.conf.in

View File

@@ -0,0 +1,35 @@
########################################################################
#
# Copyright (c) 2009, Secure Endpoints Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# - Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# - Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in
# the documentation and/or other materials provided with the
# distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
RELDIR=tests\java
!include ../../windows/NTMakefile.w32

View File

@@ -0,0 +1,101 @@
#!/bin/sh
#
# Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
# (Royal Institute of Technology, Stockholm, Sweden).
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Institute nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Id
#
srcdir="@srcdir@"
objdir="@objdir@"
port="@port@"
# Disable test if: no data, no java, or socket wrapper
../db/have-db || exit 77
sh ${srcdir}/have-java.sh || exit 77
[ X"$SOCKET_WRAPPER_DIR" != X ] && exit 77
R=TEST.H5L.SE
kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -r $R"
kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=127.0.0.1 -P $port"
KRB5_CONFIG="${objdir}/krb5.conf"
export KRB5_CONFIG
rm -f ${keytabfile} messages.log
rm -f current-db*
rm -f out-*
rm -f mkey.file*
echo "Compile"
javac -d "${objdir}" "${srcdir}/KerberosInit.java" || \
{ echo "Failed to compile java program: $?" ; exit 77; }
> messages.log
echo Creating database
${kadmin} \
init \
--realm-max-ticket-life=1day \
--realm-max-renewable-life=1month \
${R} || exit 1
${kadmin} add -p foo --use-defaults lha@${R} || exit 1
${kadmin} modify --attributes=+requires-pre-auth lha@${R} || exit 1
echo Starting kdc
${kdc} &
kdcpid=$!
sh ${srcdir}/../kdc/wait-kdc.sh
if [ "$?" != 0 ] ; then
kill ${kdcpid}
exit 1
fi
trap "kill ${kdcpid}; echo signal killing kdc; exit 1;" EXIT
echo "Run init"
java \
-Dsun.security.krb5.debug=true \
-Djava.security.krb5.conf="${objdir}"/krb5.conf \
-Djava.security.auth.login.config="${srcdir}/jaas.conf" \
KerberosInit > output.tmp 2>&1 || { cat output.tmp ; exit 1; }
echo "Done"
echo "killing kdc (${kdcpid})"
kill $kdcpid || exit 1
trap "" EXIT
exit 0

View File

@@ -0,0 +1,58 @@
#!/bin/sh
#
# Copyright (c) 2007 Kungliga Tekniska Högskolan
# (Royal Institute of Technology, Stockholm, Sweden).
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Institute nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Id
#
echo "Checking for java and javac"
oldifs=$IFS
IFS=:
set -- $PATH
IFS=$oldifs
for i in $*; do
test -n "$i" || i="."
test -x $i/java && j=f
test -x $i/javac && k=c
done
test "$j$k" = fc || exit 1
# GNU GCC Java doesn't support Kerberos
if java -version 2>&1 | grep 'gij' > /dev/null ; then
exit 1
fi
echo "ok"
exit 0

View File

@@ -0,0 +1,5 @@
/* Id */
kinit {
com.sun.security.auth.module.Krb5LoginModule required;
};

View File

@@ -0,0 +1,28 @@
# Id
[libdefaults]
default_realm = TEST.H5L.SE
[realms]
TEST.H5L.SE = {
kdc = localhost:@port@
}
[kdc]
database = {
dbname = @objdir@/current-db
realm = TEST.H5L.SE
mkey_file = @objdir@/mkey.file
}
[logging]
kdc = 0-/FILE:@objdir@/messages.log
default = 0-/FILE:@objdir@/messages.log
# Have both default and non default salting for single DES encryptes,
# this to check if the kdc return default salting.
[kadmin]
default_keys = aes256-cts-hmac-sha1-96:pw-salt
default_keys = aes128-cts-hmac-sha1-96:pw-salt
default_keys = des3-cbc-sha1:pw-salt